diff -r 1b0b563a81e6 mcabber/mcabber/commands.c
--- a/mcabber/mcabber/commands.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.c	Wed May 15 12:48:30 2013 +0300
@@ -3288,8 +4242,288 @@
 #endif
 }
 
+enum room_names_style_t {
+  room_names_style_normal = 0,
+  room_names_style_detail,
+  room_names_style_short,
+  room_names_style_quiet,
+  room_names_style_compact,
+};
+
+// room_names() is a variation of do_info(), for chatrooms only
+static void room_names(gpointer bud, enum room_names_style_t style)
+{
+  const char *bjid;
+  char *buffer;
+  GSList *resources, *p_res;
+
+  // Enter chat mode
+  scr_set_chatmode(TRUE);
+  scr_show_buddy_window();
+
+  bjid = buddy_getjid(bud);
+
+  buffer = g_slice_alloc(4096);
+  strncpy(buffer, "Room members:", 127);
+  scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
+
+  resources = buddy_getresources(bud);
+  for (p_res = resources ; p_res ; p_res = g_slist_next(p_res)) {
+    enum imstatus rstatus;
+    const char *rst_msg;
+
+    rstatus = buddy_getstatus(bud, p_res->data);
+    rst_msg = buddy_getstatusmsg(bud, p_res->data);
+
+    if (style == room_names_style_short) {
+      snprintf(buffer, 4095, "[%c] %s%s%s", imstatus2char[rstatus],
+               (char*)p_res->data,
+               rst_msg ? " -- " : "", rst_msg ? rst_msg : "");
+      scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
+    } else if (style == room_names_style_compact) {
+        enum imrole role = buddy_getrole(bud, p_res->data);
+        enum imaffiliation affil = buddy_getaffil(bud, p_res->data);
+        bool showaffil = (affil != affil_none);
+
+        snprintf(buffer, 4095, "[%c] %s (%s%s%s)",
+                 imstatus2char[rstatus], (char*)p_res->data,
+                 showaffil ? straffil[affil] : "\0",
+                 showaffil ? "/" : "\0",
+                 strrole[role]);
+        scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
+      } else {
+      // (Style "normal", "detail" or "quiet")
+      snprintf(buffer, 4095, "[%c] %s", imstatus2char[rstatus],
+               (char*)p_res->data);
+      scr_WriteIncomingMessage(bjid, buffer, 0, HBB_PREFIX_INFO, 0);
+      if (rst_msg && style != room_names_style_quiet) {
+        snprintf(buffer, 4095, "Status message: %s", rst_msg);
+        scr_WriteIncomingMessage(bjid, buffer,
+                                 0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
+      }
+      if (style == room_names_style_detail) {
+        enum imrole role = buddy_getrole(bud, p_res->data);
+        enum imaffiliation affil = buddy_getaffil(bud, p_res->data);
+
+        snprintf(buffer, 4095, "Role: %s", strrole[role]);
+        scr_WriteIncomingMessage(bjid, buffer,
+                                 0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
+        if (affil != affil_none) {
+          snprintf(buffer, 4095, "Affiliat.: %s", straffil[affil]);
+          scr_WriteIncomingMessage(bjid, buffer,
+                                   0, HBB_PREFIX_INFO | HBB_PREFIX_CONT, 0);
+        }
+      }
+    }
+    g_free(p_res->data);
+  }
+  g_slist_free(resources);
+  g_slice_free1(4096, buffer);
+}
+
 static void do_room(char *arg)
 {
+  enum room_scmd_t {
+    room_scmd_join, room_scmd_leave,
+    room_scmd_names,
+    room_scmd_nick,
+    room_scmd_privmsg,
+    room_scmd_remove,
+    room_scmd_topic,
+    room_scmd_unlock,
+    room_scmd_destroy,
+    room_scmd_whois,
+    room_scmd_ban, room_scmd_unban,
+    room_scmd_invite, room_scmd_kick,
+    room_scmd_role, room_scmd_affil,
+    room_scmd_setopt, room_scmd_bookmark,
+  } subcmd;
+  cmdopts_t options = {
+    "room",
+    (cmdopt_t[1]){
+      { CMDOPT_LAST, 'j', "jid", { .opt = NULL } },
+    },
+    (cmdarg_t[1]){
+      { CMDOPT_REQUIRED | CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+    },
+    (cmdopts_t[18]){
+      { "join", NULL,
+        (cmdarg_t[3]){
+          { 0,           { .arg = "." } },  // room jid
+          { 0,           { .arg = NULL } }, // nick
+          { CMDOPT_LAST, { .arg = NULL } }, // password
+        },
+        NULL, (gpointer)room_scmd_join, 0 },
+      { "leave", NULL,
+        (cmdarg_t[1]){
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_join, 0 },
+      { "names",
+        (cmdopt_t[4]){
+          { CMDOPT_SWITCH,               'd', "detail",  { .swc = 0 } },
+          { CMDOPT_SWITCH,               's', "short",   { .swc = 0 } },
+          { CMDOPT_SWITCH,               'q', "quiet",   { .swc = 0 } },
+          { CMDOPT_SWITCH | CMDOPT_LAST, 'c', "compact", { .swc = 0 } },
+        },
+        NULL, NULL, (gpointe)room_scmd_names, 0 },
+      { "nick", NULL,
+        (cmdarg_t[1]){
+          // nick
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_nick, 0 },
+      { "privmsg", NULL,
+        (cmdarg_t[2]) {
+          // nick
+          { CMDOPT_REQUIRED, { .arg = NULL } },
+          // message
+          { CMDOPT_REQUIRED | CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST,
+            { .arg = NULL } },
+        }
+        NULL, (gpointer)room_scmd_privmsg, 0 },
+      { "remove", NULL, NULL, NULL, (gpointer)room_scmd_remove, 0 },
+      { "topic", NULL,
+        (cmdarg_t[1]){
+          // topic
+          { CMDOPT_REQUIRED | CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST,
+            { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_topic, 0 },
+      { "unlock", NULL, NULL, NULL, (gpointer)room_scmd_unlock, 0 },
+      { "destroy", NULL,
+        (cmdarg_t[1]){
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_destroy, 0 },
+      { "whois", NULL,
+        (cmdarg_t[1]){
+          // nick
+          { CMDOPT_REQUIRED | CMDOPT_LAST, { .arg = NULL } },
+        }, NULL, (gpointer)room_scmd_whois, 0 },
+      { "ban", NULL,
+        (cmdarg_t[2]){
+          // nick
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        }, NULL, (gpointer)room_scmd_ban, 0 },
+      { "unban", NULL,
+        (cmdarg_t[1]){
+          // nick
+          { CMDOPT_REQUIRED | CMDOPT_LAST, { .arg = NULL } },
+        }, NULL, (gpointer)room_scmd_unban, 0 },
+      { "invite", NULL, // XXX [-d|direct] ?
+        (cmdarg_t[2]){
+          // jid
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_invite, 0 },
+      { "kick", NULL,
+        (cmdarg_t[2]){
+          // jid
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        },
+        NULL, (gpointer)room_scmd_kick, 0 },
+      { "role", NULL,
+        (cmdarg_t[3]){
+          // jid
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // role
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        }, NULL, (gpointer)room_scmd_role, 0 },
+      { "affil", NULL,
+        (cmdarg_t[3]){
+          // jid
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // affiliation
+          { CMDOPT_REQUIRED,                              { .arg = NULL } },
+          // reason
+          { CMDOPT_CATCHALL | CMDOPT_PLAIN | CMDOPT_LAST, { .arg = NULL } },
+        }, NULL, (gpointer)room_scmd_affil, 0 },
+      // XXX below goes some crazy subcommands stuff, that should be rather static lists
+      { "setopt", NULL,
+        (cmdarg_t[1]){
+          { CMDOPT_REQUIRED | CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+        },
+        (cmdopts_t[3]){
+          { "print_status", NULL,
+            (cmdarg_t[1]){
+              { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+            },
+            (cmdopts_t[4]){
+              { "default",    NULL, NULL, NULL, NULL, 0 },
+              { "none",       NULL, NULL, NULL, NULL, 0 },
+              { "in_and_out", NULL, NULL, NULL, NULL, 0 },
+              { "all",        NULL, NULL, NULL, NULL, CMDOPT_LAST },
+            }, NULL, 0 },
+          { "auto_whois", NULL,
+            (cmdarg_t[1]){
+              { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+            },
+            (cmdopts_t[3]){
+              { "default", NULL, NULL, NULL, NULL, 0 },
+              { "off",     NULL, NULL, NULL, NULL, 0 },
+              { "on",      NULL, NULL, NULL, NULL, CMDOPT_LAST },
+            }, NULL, 0 },
+          { "flag_joins", NULL,
+            (cmdarg_t[1]){
+              { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+            },
+            (cmdopts_t[4]){
+              { "default", NULL, NULL, NULL, NULL, 0 },
+              { "none",    NULL, NULL, NULL, NULL, 0 },
+              { "joins",   NULL, NULL, NULL, NULL, 0 },
+              { "all",     NULL, NULL, NULL, NULL, CMDOPT_LAST },
+            }, NULL, CMDOPT_LAST },
+        }, (gpointer)room_scmd_setopt, 0 },
+      { "bookmark", NULL,
+        (cmdarg_t[1]){
+          { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+        },
+        (cmdopts_t[2]){
+          { "add", NULL,
+            (cmdarg_t[1]){
+              { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+            },
+            (cmdopts_t[2]){
+              { "+autojoin", NULL,
+                (cmdarg_t[1]){
+                  // nick
+                  { CMDARG_LAST, { .arg = NULL } },
+                }, NULL, NULL, 0 },
+              { "-autojoin", NULL,
+                (cmdarg_t[1]){
+                  // nick
+                  { CMDARG_LAST, { .arg = NULL } },
+                }, NULL, NULL, CMDOPT_LAST },
+            }, NULL, 0 },
+          { "del", NULL,
+            (cmdarg_t[1]){
+              { CMDOPT_SUBCOMMAND | CMDOPT_LAST, { .cmd = NULL } },
+            },
+            (cmdopts_t[2]){
+              { "+autojoin", NULL,
+                (cmdarg_t[1]){
+                  // nick
+                  { CMDARG_LAST, { .arg = NULL } },
+                }, NULL, NULL, 0 },
+              { "-autojoin", NULL,
+                (cmdarg_t[1]){
+                  // nick
+                  { CMDARG_LAST, { .arg = NULL } },
+                }, NULL, NULL, CMDOPT_LAST },
+            }, NULL, 0 },
+        }, (gpointer)room_scmd_bookmark, CMDOPT_LAST },
+    },
+  };
   char **paramlst;
   char *subcmd;
   gpointer bud;
@@ -3347,7 +4581,7 @@
       cmd_room_leave(bud, arg);
   } else if (!strcasecmp(subcmd, "names"))  {
     if ((arg = check_room_subcommand(arg, FALSE, bud)) != NULL)
-      room_names(bud, arg);
+      room_names(bud, room_names_style_normal); // FIXME
   } else if (!strcasecmp(subcmd, "nick"))  {
     if ((arg = check_room_subcommand(arg, FALSE, bud)) != NULL)
       room_nick(bud, arg);
@@ -4162,5 +5396,6 @@
   }
   mcabber_set_terminate_ui();
 }
+#endif
 
 /* vim: set expandtab cindent cinoptions=>2\:2(0 sw=2 ts=2:  For Vim users... */
diff -r 1b0b563a81e6 mcabber/mcabber/commands.h
--- a/mcabber/mcabber/commands.h	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/commands.h	Wed May 15 12:48:30 2013 +0300
@@ -5,32 +5,394 @@
 
 #include <mcabber/config.h>
 
-// Command structure
+//
+//  DONE(?):
+//
+// * Clustering of options/switches
+//   - with separate values - just specify the same index
+//   - use the same flags on all of the clustered options, or result may be a bit unpredictable
+// * for now we'll do without multi-options.
+// * checks
+//   - argument type == public struct with name and callbacks, simple!
+//   - command checks should be just single callbacks
+//   - argument checker needs:
+//     - [in] value string (current or default)
+//     - [in] additional input data for some generic checkers (like string2enum wordlist)
+//     - [out] replacement value (not necessary string)
+//       - replacement value may need freeing
+//     - [out] error string
+//       - that may need freeing
+//
+//  TODO:
+//
+// * checkers can use visited flag to check if value is rw
+//   - but what if in-checker assigns ro value, like buddy_getjid()?
+//   - maybe need separate flag for that
+// * now, that we have rjid, merge bjid/fjid checkers into one
+// * Usable documentation in sources/howto
+// * Changelog entry
+// * --help
+//   - use argument type names and clarify, if needed in descriptions
+//   - command/subcommand descriptions
+//   - or maybe just do "/help foo"
+// * Add argument type field and subsystem to check values. Uses so far:
+//   - fjid (handle . and ./resource, perform check_jid_syntax())
+//   - bjid (handle ., strip resource, perform check_jid_syntax())
+//   - bjid in roster/buddylist (result - buddy?)
+//   - name in roster/buddylist (result - buddy?)
+//   - group in roster (result - buddy?)
+//   - other non-space string (strip trailing/starting spaces)
+//     - statusmask (restrictive, check symbols)
+//     - jidmask (non-restrictive, compl: inform what jids match)
+//     - search string (non-restrictive, compl: inform what matches, if possible)
+//     - rosternote (non-restrictive)
+//     - color (restrictive, semi-defined list)
+//     - nick (non-restrictive)
+//     - defined lists (restrictive)
+//     - date (restrictive)
+//     - percent (numerical, restrictive)
+//   - number (result - uint)
+//   - filename (expand_filename(), g_utf8_to_filename()?)
+//   - custom (maybe some helpers for constant stringlists)
+//   - text message (compl: nicks in rooms, dictionary?)
+// * Non-argument checks for commands/subcommands:
+//   - xmpp_is_online()
+//   - current_buddy
+// * commands:
+//   - say/msay/say_to/room privmsg/process_line() - sort things out, maybe write special argchecker
+//   - buffer close now only accepts windows with jid. additional checker, that also allows current 'status' buffer?
+// * Usable subsystem for completion, based on user-supplied completors
+// * Interface to history subsystem - command should have a way to inform, that it should not be stored in history.
+//
+//  XXX:
+//
+// * while escaped aliases should not be expanded, we should still unquote them for command search
+// * allow escaping in options?
+// * merge cmdopt_t and cmdarg_t?
+//   - improve the checker error messages
+//   - extra NULLs to specify in arg definition
+//   - inconvenient positioning of shortopt/longopt or argname in sequence
+//   - merge options/arguments?
+//   - describe values, not opt/args?
+// * command ref and name in special value 0 and indexing starts from 1?
+//   - requires allocation of values always
+//   - though there's not that many commands without arguments
+// * command checker is not quite effective
+//   - I'd like to run it before allocating anything
+//   - so far only one of them
+// * unable to put checker before allocation because in many cases it will be in subcommand.
+//   - separate command/subcommand values and use subcommand callbacks?
+//   - ignore command options and always go directly to subcommand parsing if present?
+//     (i.e. subcommand is always first argument and consumes the end of the line
+// * type name generator callback
+//   for generic types to construct something like "foo|bar|baz"
+// * [+foo|-foo] support?
+// * Subcommands with fallback to argument?
+// * Multivalue options
+//   - list
+//     - special checker
+//     - or run checker multiple times
+//   - or run command several times
+//     - what if there are several of such arguments?
+//
+
+//
+//  Type predeclarations
+//
+
+typedef struct cmdopts_struct      cmdopts_t;
+typedef struct cmdopt_struct       cmdopt_t;
+typedef struct cmdarg_struct       cmdarg_t;
+typedef struct cmdarg_type_struct  cmdarg_type_t;
+typedef struct cmdarg_value_struct cmdarg_value_t;
+
+//
+//  Callback type definitions
+//
+
+// Command execution environment check function.
+// Note: This is called before options are parsed, but values are already allocated.
+typedef gchar *(*cmd_checker_t)(const cmdopts_t *command, cmdarg_value_t *args);
+// Command function itself.
+// Command definition is provided for userdata access, should not be modified.
+typedef gchar *(*cmd_handler_t)(const cmdopts_t *command, cmdarg_value_t *args);
+// Should check value -> value.arg and replace, if needed.
+// Can set cmdarg_freeme flag to request type destructor call.
+// Can access argument definition via value -> src (but not modify it).
+typedef gchar *(*cmdarg_checker_t)(cmdarg_value_t *value);
+// Free resources, used in value, if needed.
+typedef void (*cmdarg_destructor_t)(cmdarg_value_t *value);
+// TODO Return possible completions for given argument.
+typedef void (*cmdarg_completor_t)(void);
+
+//
+//  Data type definitions
+//
+
+// command description flags
+typedef enum {
+  cmd_default     = 0x0000, // no flags
+  cmd_safe        = 0x0001, // command is safe to use in mcabberrc
+} cmd_flags_t;
+// argument description flags
+typedef enum {
+  cmdarg_default  = 0x0000, // no flags
+  cmdarg_catchall = 0x0001, // argument consumes the end of command line
+  cmdarg_plain    = 0x0002, // quotes and escapes are not processed
+  cmdarg_check    = 0x0004, // forse checker call on argument
+  cmdarg_required = 0x0008, // checker errors are fatal (checker may use as well)
+  cmdarg_subcmd   = 0x0010, // argument is subcommand
+  cmdarg_switch   = 0x0020, // option without argument, value is count
+  // shortcuts:
+  cmdarg_eol      = 0x0003, // catchall + plain
+  cmdarg_chreq    = 0x000C, // check + required
+  cmdarg_special  = 0x0030, // subcmd + switch
+  cmdarg_trigger  = 0x0024, // switch + check
+} cmdarg_flags_t;
+// argument value flags (internal)
+typedef enum {
+  cmdval_default  = 0x0000, // no flags
+  cmdval_visited  = 0x0100, // marks initialized arguments
+  cmdval_freeme   = 0x0200, // marks argument, that needs freeing
+} cmdval_flags_t;
+
+// command description
+struct cmdopts_struct {
+  const char          *name;     // [user,req] command name (error messages, help, subcommands)
+  const cmd_flags_t   flags;     // [user,req] safe
+  const cmd_checker_t check;     // [user,req] checker routine
+  const cmd_handler_t handle;    // [user,req] main command processing function
+  const cmdopt_t      *opts;     // [user,req] options
+  const cmdarg_t      *args;     // [user,req] arguments
+  const cmdopts_t     *cmds;     // [user,req] subcommands
+  gconstpointer       userdata;  // [user]
+  size_t              valno;     // internal, number of values to allocate
+};
+// positional/option argument description
+struct cmdarg_struct {
+  const char           *name;    // [user,req] argument name - errors, help (unused for switches, but must be initialized)
+  const size_t         pos;      // [user,req] value positional number
+  const cmdarg_flags_t flags;    // [user,req] catchall, plain, check, required, subcommand, switch
+  const char           *defval;  // [user,req] default value (unused for switches)
+  const cmdarg_type_t  *type;    // [user,req] type cbs - checker and completor (unused for switches and subcommands)
+  gconstpointer        chkdata;  // [user] instance data for type checker - eg string2enum list (unused for switches and subcommands)
+  gconstpointer        userdata; // [user]
+};
+// option description
+struct cmdopt_struct {
+  const char           shortopt; // [user,req]
+  const char           *longopt; // [user,req]
+  cmdarg_t             arg;      // [user,req]
+};
+// argument type description
+struct cmdarg_type_struct {
+  cmdarg_checker_t    check;     // [user,req] check string and set argument value
+  cmdarg_destructor_t free;      // [user,req] free argument value
+  cmdarg_completor_t  complete;  // [user,req]
+};
+// argument value
+struct cmdarg_value_struct {
+  const cmdarg_t *src;           // source of value
+  cmdval_flags_t flags;          // visited, freeme
+  union {                        // value:
+    unsigned long   uint;        // - unsigned integer
+    long            sint;        // - signed integer
+    guint           swc;         // - switch count
+    const gchar     *roarg;      // - XXX default value
+    gchar           *arg;        // - string argument
+    const cmdopts_t *cmd;        // - subcommand
+    struct {                     // - roster jid:
+      gpointer      bud;         //   - buddy struct
+      gchar         *resource;   //   - resource (optional)
+    } rjid;                      // 
+    struct {                     // - filename
+      gchar         *utf8;       //   - in utf8
+      gchar         *local;      //   - in local FS encoding
+    } fname;                     //
+    struct {                     // - key [= [value]]
+      gchar         *key;        //   - key
+      gchar         *value;      //   - value
+      gboolean      assignment;  //   - '=' was specified
+    } assign;                    //
+    time_t          time;        // - date/time
+    gpointer        ptr;         // - anything else
+  } value;                       //
+};
+
+//
+//  Public functions
+//
+
+// add command definition
+void cmd_define (cmdopts_t *command);
+// remove command definition
+void cmd_undef (cmdopts_t *command);
+
+//  error cmdopts_parse_argument ( startptr, endptr, flags )
+// Parses next argument according to flags and finishes it with zero.
+// Updates current/end pointers. Parsed string MUST be writable.
+// String may shrink in size (quotation/escapes), thus endpointer is also
+// updated.
+const char *cmdopts_parse_argument(gchar **pr, gchar **er, cmdarg_flags_t flags);
+
+// flags for cmd_execute()
+typedef enum {
+  cmdexe_default        = 0,    // no flags
+  cmdexe_check_safe     = 1<<0, // we're parsing main config file
+  cmdexe_check_verbatim = 1<<1, // check for verbatim input mode
+} cmdexe_flags_t;
+// return codes for cmd_execute() and process_line()
+typedef enum {
+  cmd_result_ok   = 0,       // all is ok
+  cmd_result_syntax_error,   // syntax or environment check error
+  cmd_result_value_error,    // argument value missing or type check error
+  cmd_result_not_found,      // no such command
+  cmd_result_runtime_error,  // error while executing command
+  cmd_result_verbatim,       // we're in verbatim mode and this is not "msay"
+  cmd_result_input,          // [process_line only] line was a message
+  cmd_result_quit = 255,     // this is hard-coded "quit" command
+} cmd_result_t;
+
+//  error cmd_execute ( command, flags )
+// Checks for "quit", "msay" in verbatim mode, expands aliases, checks command
+// for safety of execution, parses command's arguments according to definition,
+// executes command function. Returns cmdexe_result_ok (0) if all was ok.
+// Non-zero values mean, that command was not executed for some reason.
+// One special value is cmd_result_quit (255) - if it is "quit" command.
+cmd_result_t cmd_execute (gchar *commandline, cmdexe_flags_t flags);
+
+//  process_line(line)
+// Process a command/message line. If this isn't a command, this is a message
+// and it is sent to the currently selected buddy. The line is converted from
+// local encoding to utf8.
+// Returns 255 if the line is the /quit command, 0 on success and some other
+// error codes.
+cmd_result_t process_line(const char *line);
+
+//
+//  Command checkers
+//
+
+// checks if connection is available
+gchar *cmd_check_online (const cmdopts_t *command, cmdarg_value_t *values);
+gchar *cmd_check_current_buddy (const cmdopts_t *command, cmdarg_value_t *values);
+
+//
+//  Standard argument types
+//
+
+// enum for chkdata for roster/jid checkers
+typedef enum {
+  cmdarg_roster_notset    = 0x0000,
+  cmdarg_roster_user      = ROSTER_TYPE_USER,    // 0x0001
+  cmdarg_roster_group     = ROSTER_TYPE_GROUP,   // 0x0002
+  cmdarg_roster_agent     = ROSTER_TYPE_AGENT,   // 0x0004
+  cmdarg_roster_room      = ROSTER_TYPE_ROOM,    // 0x0008
+  cmdarg_roster_special   = ROSTER_TYPE_SPECIAL, // 0x0010
+  cmdarg_roster_name      = 0x0100,              // namesearch
+  cmdarg_roster_activeres = 0x0200,              // active resource
+  cmdarg_roster_getgroup  = 0x0400,              // group of buddy
+  // shortcuts:
+  cmdarg_roster_buddy     = 0x0005, // user + agent (single buddy)
+  cmdarg_roster_entity    = 0x000D, // user + agent + room (xmpp entity)
+  cmdarg_roster_buffer    = 0x001D, // user + agent + room + special (have buffer)
+  cmdarg_roster_normal    = 0x000F, // user + group + agent + room (not special)
+  cmdarg_roster_all       = 0x001F, // user + group + agent + room + special
+  cmdarg_roster_grouponly = 0x0402, // group + getgroup (search group buddy)
+  cmdarg_roster_mask      = 0x001F, // all
+} cmdarg_roster_t;
+
+// array entry for chkdata for string2enum checker
 typedef struct {
-  char name[32];
-  const char *help;
-  guint completion_flags[2];
-  void (*func)(char *);
-  gpointer userdata;
-} cmd;
+  const char *name;
+  int        value;
+} string2enum_t;
 
-void cmd_init(void);
-cmd *cmd_get(const char *command);
-int  process_line(const char *line);
-int  process_command(const char *line, guint iscmd);
-char *expandalias(const char *line);
-#ifdef MODULES_ENABLE
-gpointer cmd_del(gpointer id);
-gpointer cmd_add(const char *name, const char *help, guint flags1, guint flags2,
-                 void (*f)(char*), gpointer userdata);
-gboolean cmd_set_safe(const gchar *name, gboolean safe);
+// destructor, that g_free()s value.arg
+void cmdarg_free_gfree (cmdarg_value_t *arg);
+
+// strips space at the start/end and ensures, that string have non-zero length
+gchar *cmdarg_check_nonspace        (cmdarg_value_t *arg);
+// checks, that jid is in roster and returns buddy
+gchar *cmdarg_check_roster_bjid     (cmdarg_value_t *arg);
+// checks, that name is in roster and returns buddy
+gchar *cmdarg_check_roster_name     (cmdarg_value_t *arg);
+// checks, that jid is in roster and have specified resource, returns buddy and resource
+gchar *cmdarg_check_roster_resource (cmdarg_value_t *arg);
+// checks for group with given name and returns buddy
+gchar *cmdarg_check_roster_group    (cmdarg_value_t *arg);
+// checks correctness of jid syntax
+gchar *cmdarg_check_fjid            (cmdarg_value_t *arg);
+// checks correctness of jid syntax, strips resource
+gchar *cmdarg_check_bjid            (cmdarg_value_t *arg);
+// transforms to guint
+gchar *cmdarg_check_uint            (cmdarg_value_t *arg);
+// checks, that string consists of characters from a given set
+gchar *cmdarg_check_charset         (cmdarg_value_t *arg);
+// checks, that string is from the given list, and returns corresponding guint value
+gchar *cmdarg_check_string2enum     (cmdarg_value_t *arg);
+// checks mcabber color name syntax
+gchar *cmdarg_check_color           (cmdarg_value_t *arg);
+// expands filename and converts encoding
+gchar *cmdarg_check_filename        (cmdarg_value_t *arg);
+// destructor, frees both names
+void cmdarg_free_fname              (cmdarg_value_t *arg);
+// converts iso-8601 date to epoch
+gchar *cmdarg_check_date            (cmdarg_value_t *arg);
+
+// ready for use standard type descriptions
+const cmdarg_type_t cmdarg_type_nonspace;
+const cmdarg_type_t cmdarg_type_roster_bjid;
+const cmdarg_type_t cmdarg_type_roster_name;
+const cmdarg_type_t cmdarg_type_roster_resource;
+const cmdarg_type_t cmdarg_type_roster_group;
+const cmdarg_type_t cmdarg_type_fjid;
+const cmdarg_type_t cmdarg_type_bjid;
+const cmdarg_type_t cmdarg_type_uint;
+const cmdarg_type_t cmdarg_type_charset;
+const cmdarg_type_t cmdarg_type_string2enum;
+const cmdarg_type_t cmdarg_type_color;
+const cmdarg_type_t cmdarg_type_filename;
+const cmdarg_type_t cmdarg_type_date;
+
+//
+//  Private
+//
+
+void cmd_init (void);
+void cmd_uninit (void);
+
+#if 0
+// return highest index for value, used in command
+size_t cmdopts_count_values (const cmdopts_t *command);
+
+// allocate values array to store arguments
+cmdarg_value_t *cmdopts_allocate_values (const cmdopts_t *command);
+
+//  error cmdopts_parse_internal ( startptr, endptr, commanddef, values )
+// Parses command arguments according to command definition.
+// Parsed string MUST be writable. Regardless of success or error, input
+// string should be considered corrupted by parsing process.
+gchar *cmdopts_parse_internal (gchar **pr, gchar **er, const cmdopts_t *command, cmdarg_value_t *values);
+
+// perform type checking/conversion on parsed values
+gchar *cmdopts_check_values (const cmdopts_t *command, cmdarg_value_t *values);
+
+//  cmdopts_free_values ( commanddef, values )
+// Free allocated by checkers resources and values array.
+void cmdopts_free_values (const cmdopts_t *command, cmdarg_value_t *values);
+
+typedef enum {
+  msgtype_not_set,
+  msgtype_normal,
+  msgtype_headline,
+} msgtype_t;
+
+void say_cmd(char *arg, msgtype_t msgtype);
 #endif
-gboolean cmd_is_safe(const gchar *name);
 
 void cmd_room_whois(gpointer bud, const char *nick, guint interactive);
 void cmd_room_leave(gpointer bud, char *arg);
-void cmd_setstatus(const char *recipient, const char *arg);
-void say_cmd(char *arg, int parse_flags);
 
 #endif /* __MCABBER_COMMANDS_H__ */
 
diff -r 1b0b563a81e6 mcabber/mcabber/hooks.c
--- a/mcabber/mcabber/hooks.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/hooks.c	Wed May 15 12:48:30 2013 +0300
@@ -638,10 +638,9 @@
 
   scr_LogPrint(LPRINT_LOGNORM, "Running hook-post-connect...");
 
-  cmdline = from_utf8(hook_command);
-  if (process_command(cmdline, TRUE) == 255)
+  cmdline = g_strdup(hook_command);
+  if (cmd_execute(cmdline, cmd_default) == cmd_result_quit)
     mcabber_set_terminate_ui();
-
   g_free(cmdline);
 }
 
@@ -665,10 +664,9 @@
 
   scr_LogPrint(LPRINT_LOGNORM, "Running hook-pre-disconnect...");
 
-  cmdline = from_utf8(hook_command);
-  if (process_command(cmdline, TRUE) == 255)
+  cmdline = g_strdup(hook_command);
+  if (cmd_execute(cmdline, cmd_default) == cmd_result_quit)
     mcabber_set_terminate_ui();
-
   g_free(cmdline);
 }
 
diff -r 1b0b563a81e6 mcabber/mcabber/roster.c
--- a/mcabber/mcabber/roster.c	Wed Mar 13 16:11:16 2013 +0200
+++ b/mcabber/mcabber/roster.c	Wed May 15 12:48:30 2013 +0300
@@ -1586,13 +1586,14 @@
 // Look for a buddy whose name or jid contains string.
 // Search begins at current_buddy; if no match is found in the the buddylist,
 // return NULL;
+// Note: before this function considered its argument to be in local encoding,
+//       now argument must be in utf8.
 GList *buddy_search(char *string)
 {
   GList *buddy = current_buddy;
   roster *roster_usr;
   if (!buddylist || !current_buddy) return NULL;
   for (;;) {
-    gchar *jid_locale, *name_locale;
     char *found = NULL;
 
     buddy = g_list_next(buddy);
@@ -1601,17 +1602,13 @@
 
     roster_usr = (roster*)buddy->data;
 
-    jid_locale = from_utf8(roster_usr->jid);
-    if (jid_locale) {
-      found = strcasestr(jid_locale, string);
-      g_free(jid_locale);
+    if (roster_usr->jid) {
+      found = strcasestr(roster_usr->jid, string);
       if (found)
         return buddy;
     }
-    name_locale = from_utf8(roster_usr->name);
-    if (name_locale) {
-      found = strcasestr(name_locale, string);
-      g_free(name_locale);
+    if (roster_usr->name) {
+      found = strcasestr(roster_usr->name, string);
       if (found)
         return buddy;
     }
